import { h } from '@stencil/core';
export class RLTextLog {
    constructor() {
        this.strings = [];
    }
    /**
     * Add a new line to the log.
     * @param str A string to write to the log
     */
    async log(str = '') {
        this.strings = [...this.strings, str];
    }
    hostData() {
        return {
            class: {
                'rl-text-log': true,
            }
        };
    }
    render() {
        return this.strings.map(s => h("div", null, s));
    }
    static get is() { return "rl-text-log"; }
    static get originalStyleUrls() { return {
        "$": ["text-log.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["text-log.css"]
    }; }
    static get states() { return {
        "strings": {}
    }; }
    static get methods() { return {
        "log": {
            "complexType": {
                "signature": "(str?: string) => Promise<void>",
                "parameters": [{
                        "tags": [{
                                "text": "str A string to write to the log",
                                "name": "param"
                            }],
                        "text": "A string to write to the log"
                    }],
                "references": {
                    "Promise": {
                        "location": "global"
                    }
                },
                "return": "Promise<void>"
            },
            "docs": {
                "text": "Add a new line to the log.",
                "tags": [{
                        "name": "param",
                        "text": "str A string to write to the log"
                    }]
            }
        }
    }; }
}
