import { Coordinate } from '../utils/coordinate';
interface Size {
    height: number;
    width: number;
}
/**
 * An image displayed as the icon of a `MapMarker`.
 */
export declare class MarkerIcon {
    _anchor: Coordinate;
    /**
     * The position of the icon relative to the marker.
     */
    anchor: Coordinate;
    _originalSize: {
        width: number;
        height: number;
    };
    /**
     * The natural size of the image without any scaling.
     */
    originalSize: Size;
    _size: Size;
    /**
     * The size of the image after scaling.
     */
    size: Size;
    _scale: number;
    /**
     * The factor by which to scale the image.
     */
    scale: number;
    _url: string;
    /**
     * The URL of the image.
     */
    url: string;
    /**
     * Renders the DOM necessary to display the icon.
     */
    render(): any;
}
export {};
