import { EventEmitter } from '../../stencil.core';
/**
 * A component that wraps a `Material Select Menu` component.
 */
export declare class Select {
    /**
     * Internal ID used to differentiate multiple menus.
     */
    readonly id: number;
    /**
     * Reference to the internal Material Select component.
     */
    private select;
    /**
     * Root element.
     */
    root: HTMLElement;
    /**
     * The label displayed on the select.
     */
    label: string;
    /**
     * An array of the different options displayed in the select menu.
     */
    options: string[];
    /**
     * The index of the currently selected option or undefined if nothing selected.
     */
    selectedOption?: number;
    /**
     * An event emitted when an item is selected.  The detail of the event is set
     * to the index of the item selected.
     */
    selected: EventEmitter<number>;
    componentDidLoad(): void;
    componentDidUnload(): void;
    hostData(): {
        class: {
            'mdc-select': boolean;
        };
    };
    render(): any[];
}
