import { MapMarker } from '../classes/map-marker';
import { MapPolygon } from '../classes/map-polygon';
import { MapElementDataMap, Size } from '../interface';
export declare const CONTROL_SIZE = 100;
export declare const HYSTERESIS = 8;
export declare const DEFAULT_MAX_SCALE = 3;
export declare const DEFAULT_MIN_SCALE = 1;
export declare const STATES: {
    NORMAL: number;
    GESTURE_DOWN: number;
    DRAGGING: number;
    ZOOMING: number;
    ADD_REGION_INIT: number;
    ADD_REGION_FIRST: number;
    ADD_REGION: number;
    ADD_POINT: number;
    DRAG_ELEMENT: number;
};
export declare const SVG_NS = "http://www.w3.org/2000/svg";
export declare function computeLimits(iSize: Size, sSize: Size, scale: number): DOMRect;
/**
 * Gets the ID of a given Element within the Map SVG.  This makes use of the
 * known DOM structure of the SVG.
 * @param el The Element to use to find the ID.
 */
export declare function getTargetId(el: EventTarget | null): number | undefined;
/**
 * Processes an array of `MapElement`s, turning them into an array of
 * `ParsedMapElement` objects.  These parsed map elements are then rendered onto
 * a map.
 * @param elements An array of `MapElement`s to process
 * @param scale The scale applied to the `ParsedElement`
 */
export declare function parseElements(elements: MapElementDataMap, scale?: number): (MapMarker | MapPolygon)[];
